local GameScene = Scene:extend()
local binser = require 'libs.binser'

GameScene.title = "Game"
local tas = false
require 'load.save'

function GameScene:new(player_name, replay_file, replay_grade)
    game_mode = require 'game.gamemode'
    if pent_mode then
        ruleset = require 'game.rotation_pent'
    else
        ruleset = require 'game.rotation'
    end
    self.retry_mode = game_mode
    self.retry_ruleset = ruleset
    self.secret_inputs = inputs
    self.reset_stuff = {player_name, replay_file, replay_grade}
    self.game = game_mode(player_name, replay_file, replay_grade)
    self.ruleset = ruleset(self.game)
    self.grace_frames = 0
    self.normal_volume = love.audio.getVolume()
    self.game:initialize(self.ruleset)
    self.inputs = {
        left=false,
        right=false,
        up=false,
        down=false,
        rotate_left=false,
        rotate_left2=false,
        rotate_right=false,
        rotate_right2=false,
        rotate_180=false,
        hold=false,
    }
    self.paused = false
end

function GameScene:update(nosound, tas_update)
    local inputs = {}
    if tas then 
		while self.game.are > 2 do
			self.game:update(inputs, self.ruleset)
		end
	end
    for input, value in pairs(self.inputs) do
        inputs[input] = value
    end
    if tas and tas_update then 
		self.paused = false
		self.game:update(inputs, self.ruleset)
		self.paused = true
		return
	end
    if nosound then
		love.audio.setVolume(0)
	end
    if not nosound and self.grace_frames > 0 then
		self.grace_frames = self.grace_frames - 1
		if self.grace_frames == 1 then love.audio.setVolume(self.normal_volume) end
	end
    if not self.paused then
		self.game:update(inputs, self.ruleset)
	end
end

function GameScene:render()
    self.game:draw(self.paused)
end

function GameScene:onInputPress(e)
    if (self.game.game_over or self.game.completed) and (e.input == "menu_decide" or e.input == "menu_back" or e.input == "rotate_right") and self.game.game_over_frames > 50 then
        scene = TitleScene()
    elseif tas and e.input == "menu_decide" then
		self:update(false, true)
    elseif self.game.input_playback and (e.input == "menu_back") then
        scene = TitleScene()
	elseif self.game.input_playback and e.input == "rotate_left" then
		self.paused = false
		self:update()
		self.paused = true
	elseif self.game.input_playback and e.input == "rotate_right" then
		self.paused = false
	elseif self.game.input_playback and not self.paused and e.input == 'left' then
		local target = self.game.frames - 300
		if target < 1 then target = 1 end
		self.game = game_mode(self.reset_stuff[1], self.reset_stuff[2], self.reset_stuff[3])
		self.ruleset = ruleset(self.game)
		self.game:initialize(self.ruleset)
		while self.game.frames < (target) do
			self:update(true)
		end
		self.grace_frames = 90
	elseif self.game.input_playback and not self.paused and e.input == 'right' then
		local target = self.game.frames + 600
		if target > #self.game.replay_inputs then target = #self.game.replay_inputs-10 end
		--self.game = game_mode(self.reset_stuff[1], self.reset_stuff[2], self.reset_stuff[3])
		self.ruleset = ruleset(self.game)
		self.game:initialize(self.ruleset)
		while self.game.frames < (target) do
			self:update(true)
		end
		self.grace_frames = 90
    elseif e.input and string.sub(e.input, 1, 5) ~= "menu_" then
        self.inputs[e.input] = true
    end
end

function GameScene:onInputRelease(e)
    if e.input and string.sub(e.input, 1, 5) ~= "menu_" then
        self.inputs[e.input] = false
    end
end

return GameScene
